// Visual C++ Tv IMAGEDIT x[Xł
#include <windows.h>
#include <commctrl.h>
#include <wingdi.h>
#include "resource.h"
#pragma comment(lib,"comctl32.lib")
#pragma comment(lib,"msimg32.lib")
#define MYWNDTITLE			"ImageEditer"
#define MYWNDCLASS			"ImageEditerClass"
#define WIDTHBYTES(bits)	((bits + 31) >> 5) << 2
#define CTOOLS				11				// c[{^̐
#define PWM_CHANGEBUTTON	WM_USER + 1000	// c[{^ύXꂽƂ

HWND		g_hWnd = NULL;
HWND		g_hDlg = NULL;
HWND		g_hToolbox = NULL;
HWND		g_hColorbox = NULL;
HWND		g_hAlphabox = NULL;
HINSTANCE	g_hInst = NULL;
HCURSOR		g_hcurWait = NULL;
HCURSOR		g_hcurHand = NULL;
HCURSOR		g_hcurPlg = NULL;
COLORREF	g_color = RGB(255, 255, 255);	// ݑIĂ`F
COLORREF	g_colorL = RGB(255, 255, 255);	// {^̕`F
COLORREF	g_colorR = RGB(255, 255, 255);	// E{^̕`F
COLORREF	g_colorTP = RGB(0, 0, 0);	// F
RECT		g_rc_select = {0,0,0,0};	// Ig
RECT		g_rc_plg = {0,0,0,0};		// slӌ`nh`
char		g_filename[MAX_PATH] = "";
char		szToolboxClass[] = "ToolboxClass";
char		szToolBtnClass[] = "ToolBtnClass";
char		szColorBoxClass[] = "ColorBoxClass";

int			g_CurToolBtn = -1;			// ݑIĂc[{^IDi0 ` CTOOLS-1j
int			g_xMargin = 2;				// c[{bNX̘g̕
int			g_yMargin = 2;
int			g_cxToolBtn, g_cyToolBtn;	// c[{^̃TCY
int			g_nAlpha = 255;				// xi0 ` 255j
bool		g_bTransparent = false;		// FtO
bool		g_bPasteMoving = false;		// y[Xg摜hbOړ
bool		g_bEnableMove = false;		// y[Xg摜hbOړł邩
bool		g_bMouseButtonDown = false;	// hbO
bool		g_bDisableTools = false;	// c[̎gp֎~Ă邩
bool		g_bPlgMoving = false;		// slӌ`nhhbOړ
bool		g_bPlg = false;				// slӌ``tO
POINT		g_pt_move = {0, 0};			// slӌ`nh̃hbOړ
POINT		g_pt_pre = {0, 0};			// {^Ƃ̍W
POINT		g_pt_now = {0, 0};			// ݂̍W
POINT		g_pt_now_pre = {-1, -1};	// ȑO̍W

typedef struct{
	HBITMAP		hBmp;		// BITMAP̃nh
	BITMAPINFO	*pBmi;		// BITMAPINFO\
	BYTE		*pBits;		// sNZl
	int			widthbytes;	// 4oCgE
	int			size_pBmi, size_pBits;	// BITMAPINFO\̂ƃsNZl̃obt@TCY
	int			wdh, hgt;	// 摜̃TCY
	RECT		rc;			// 摜̎l̍W
}BMPINF,*LPBMPINF;

typedef struct{
	BITMAPINFO	*pBmi;
	BYTE		*pBits;
	int			size_pBmi, size_pBits;
}CLPBRD,*LPCLPBRD;

BMPINF	g_bi1 = {NULL, NULL, NULL, 0, 0, 0, 0, 0, 0, 0};	// C摜
BMPINF	g_bi2 = {NULL, NULL, NULL, 0, 0, 0, 0, 0, 0, 0};	// y[Xg摜
BMPINF	g_biUndo = {NULL, NULL, NULL, 0, 0, 0, 0, 0, 0, 0};	// [ɖ߂]obt@
CLPBRD	g_cb = {NULL, NULL, 0, 0};	// Nbv{[hpDIB
BYTE	*g_pBitsCp = NULL;			// C摜NApobt@

typedef struct {
	HCURSOR hcur;			/* Handle to the cursor for this tool.          */
	INT idbmToolBtnUp;		/* ID of "up" bmp res. for the Toolbox button.  */
	HBITMAP hbmToolBtnUp;	/* hbm of "up" bitmap for the Toolbox button.   */
	INT idbmToolBtnDown;	/* ID of "down" bmp res. for the Toolbox button.*/
	HBITMAP hbmToolBtnDown;	/* hbm of "down" bitmap for the Toolbox button. */
} TOOLS;

TOOLS g_Tools[CTOOLS] = 
{
	{ NULL,   IDB_TUPENCIL,  NULL,   IDB_TDPENCIL,  NULL },
	{ NULL,   IDB_TUBRUSH,   NULL,   IDB_TDBRUSH,   NULL },
	{ NULL,   IDB_TUSELECT,  NULL,   IDB_TDSELECT,  NULL },
	{ NULL,   IDB_TULINE,    NULL,   IDB_TDLINE,    NULL },
	{ NULL,   IDB_TURECT,    NULL,   IDB_TDRECT,    NULL },
	{ NULL,   IDB_TUSRECT,   NULL,   IDB_TDSRECT,   NULL },
	{ NULL,   IDB_TUCIRCLE,  NULL,   IDB_TDCIRCLE,  NULL },
	{ NULL,   IDB_TUSCIRCL,  NULL,   IDB_TDSCIRCL,  NULL },
	{ NULL,   IDB_TUFLOOD,   NULL,   IDB_TDFLOOD,   NULL },
	{ NULL,   IDB_TUSPUIT,   NULL,   IDB_TDSPUIT,   NULL },
	{ NULL,   IDB_TUGRAD,    NULL,   IDB_TDGRAD,    NULL }
};

LRESULT CALLBACK ProcWnd(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
LRESULT CALLBACK ProcWndToolbox(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
LRESULT CALLBACK ProcWndToolBtn(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
BOOL CALLBACK ProcDlgColor(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam);
BOOL CALLBACK ProcDlgAlpha(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam);
BOOL CALLBACK ProcDlgNew(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam);
void Set_MoveFlag(bool bEnable);
RECT Get_ControlRect(HWND hDlg, HWND hCtrl);
void Bre_Line(HDC hDC, int x1, int y1, int x2, int y2, COLORREF clr, UINT thick);
void Bre_Line_Sub(HDC hDC, int dx, int dy, int x1, int y1, int x2, int y2, COLORREF clr, UINT thick, bool bSlantGently);
void Bre_Write_Pixel(HDC hDC, int x, int y, COLORREF clr, UINT thick, bool bSlantGently);
void Fill_Rect(HDC hDC, UINT x, UINT y, UINT width, UINT height, COLORREF clr, bool flag_RopInvert);
void T_Flood_Fill(HWND hWnd, UINT x, UINT y, COLORREF clr);
void T_Spuit(HWND hWnd, UINT x, UINT y);
void T_Draw_Line_Pre(HDC hDC, POINT pt_pre, POINT pt_now, POINT pt_now_pre);
void T_Draw_Line(HDC hDC, POINT pt_pre, POINT pt_now_pre);
void T_Draw_Rect_Pre(HDC hDC, RECT rc1, RECT rc2, bool flag_ellipse);
void T_Clear_Rect_Pre(HDC hDC, RECT rc1, bool flag_ellipse);
void T_Draw_Rect(HDC hDC, RECT rc1, RECT rc2, bool flag_ellipse, bool flag_fill);
void T_Draw_RectGrad(HDC hDC, RECT rc1, RECT rc2);
RECT T_Draw_SelectRect(HDC hDC, POINT pt_pre, POINT pt_now, POINT pt_now_pre);
void T_Clear_SelectRect();
void M_Paste();
void M_Paint(HDC hDC);
void M_ButtonDown(LPARAM lParam);
void M_ButtonUp(POINT pt);
void M_MouseMove(bool bMouseButtonDown, POINT pt);
void M_ButtonUpColorbox(HWND hDlg, HWND *hPic, COLORREF *colorS, LPARAM lParam, bool bLeft);
void Init_Plg();
void Set_PlgRect();
void Draw_EnableMoveRect(HDC hDC, RECT rc, UINT thick, COLORREF clr, UINT style);
void DrawMarginBorder(HWND hWnd, HDC hDC);
void ToolboxSelectTool(int tool);
void ToolboxDrawBitmap(HDC hDC, int tool);
bool Create_ToolBox();
void Open_ColorDlg(HWND hWnd, bool bLeft);
void Toggle_ShowWindow(HWND hWnd);
void Toggle_CheckShowWindow(HWND hWnd, HMENU hMenu, UINT menuID);
void Init_Positions();
void Set_Hcursor();
void Set_SubMenuState(HMENU hMenuSub, int index);
void Menu_Check(HMENU hMenu, UINT ID, bool bCheck);
WORD BmiSize(LPBITMAPINFOHEADER lpbih);
WORD BitMaskSize(LPBITMAPINFOHEADER lpbih);
WORD PaletteSize(LPBITMAPINFOHEADER lpbih);
WORD DIBNumColors(LPBITMAPINFOHEADER lpbih);
DWORD BytesPerLine(LPBITMAPINFOHEADER lpbih);
bool Get_Clipboard_DIB(BMPINF *bi);
bool Get_Clipboard_DDB(BMPINF *bi);
void Set_Clipboard_DIB(RECT rc);
void Set_Clipboard_DDB(RECT rc);
void Set_Clipboard_Sub(RECT rc);
void Set_Undo();
void Undo();
void Open_FileDlg();
void Save_FileDlg();
void Load_Bmp(char *filename);
void Save_Bmp(char *filename);
void Allocate_MemoryCopy();
void Release_MemoryCopy();
void Release_Memory1();
void Release_Memory2();
void Release_MemoryUndo();
void Release_MemoryClpbrd();
void Release_Memory();
void Clean_Up();

int WINAPI WinMain(HINSTANCE hInst,HINSTANCE hInstPrev,LPSTR lpCmdLine,int nCmdShow)
{
	MSG 	   msg;
	WNDCLASSEX wc;
	
	g_hInst = hInst;
	
	ZeroMemory(&wc, sizeof(wc));
	wc.cbSize = sizeof(WNDCLASSEX);
	wc.style = 0;
	wc.lpfnWndProc = (WNDPROC)ProcWndToolbox;
	wc.hInstance = hInst;
	wc.hIcon = NULL;
	wc.hCursor = LoadCursor(NULL, IDC_ARROW);
	wc.hbrBackground = (HBRUSH)GetStockObject(LTGRAY_BRUSH);
	wc.lpszMenuName = NULL;
	wc.lpszClassName = szToolboxClass;
	if(!RegisterClassEx(&wc))
		return FALSE;
	
	ZeroMemory(&wc, sizeof(wc));
	wc.cbSize = sizeof(WNDCLASSEX);
	wc.style = 0;
	wc.lpfnWndProc = (WNDPROC)ProcWndToolBtn;
	wc.hInstance = hInst;
	wc.hIcon = NULL;
	wc.hCursor = LoadCursor(NULL, IDC_ARROW);
	wc.hbrBackground = (HBRUSH)(COLOR_WINDOW + 1);
	wc.lpszMenuName = NULL;
	wc.lpszClassName = szToolBtnClass;
	if(!RegisterClassEx(&wc))
		return FALSE;
	
	ZeroMemory(&wc, sizeof(wc));
	wc.cbSize			= sizeof(WNDCLASSEX);
	wc.lpfnWndProc		= (WNDPROC)ProcWnd;
	wc.hInstance		= hInst;
	wc.hIcon			= LoadIcon(hInst, MAKEINTRESOURCE(IDI_ICON1));
	wc.hCursor			= LoadCursor(NULL, IDC_ARROW);
	wc.hbrBackground	= (HBRUSH)COLOR_WINDOW;
	wc.lpszMenuName 	= NULL;
	wc.lpszClassName	= MYWNDCLASS;
	if(!RegisterClassEx(&wc))
		return FALSE;
	
	HMENU hMenu = LoadMenu(hInst,MAKEINTRESOURCE(IDR_MENU1));
	
	HWND hWnd = CreateWindowEx(WS_EX_CLIENTEDGE | WS_EX_ACCEPTFILES, 
				MYWNDCLASS,
				MYWNDTITLE,
				WS_OVERLAPPEDWINDOW | WS_VISIBLE,
				CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT,
				NULL,
				hMenu,
				hInst,
				NULL);
	
	while(GetMessage(&msg, NULL, 0, 0)) {
		if(g_hDlg){
			if(IsDialogMessage(g_hDlg, &msg))	continue;
		}
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
	return msg.wParam;
}// WinMain

// CEBhẼvV[W
LRESULT CALLBACK ProcWnd(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch(uMsg)
	{
	case WM_CREATE:
		g_hWnd = hWnd;
		Create_ToolBox();
		g_hColorbox = CreateDialog(g_hInst, MAKEINTRESOURCE(IDD_COLORBOX), hWnd, ProcDlgColor);
		g_hAlphabox = CreateDialog(g_hInst, MAKEINTRESOURCE(IDD_ALPHABOX), hWnd, ProcDlgAlpha);
		ShowWindow(g_hColorbox, SW_SHOW);
		Set_Hcursor();
		InitCommonControls();
		if(__argc > 1){
			Load_Bmp(__argv[1]);
			SetRect(&g_rc_select, 0, 0, g_bi1.wdh, g_bi1.hgt);
		}
		return 0;
	case WM_MOVE:
	case WM_SIZE:
		Init_Positions();
		return 0;
	case WM_DROPFILES:		// hbvt@C󂯎
		{
			HDROP	hDrop;
			char	fname[MAX_PATH] = "";
			hDrop = (HDROP) wParam;
			DragQueryFile(hDrop, 0, fname, sizeof(fname));
			Load_Bmp(fname);
			DragFinish(hDrop);
			SetRect(&g_rc_select, 0, 0, g_bi1.wdh, g_bi1.hgt);
			InvalidateRect(hWnd, NULL, TRUE);
		}
		break;
	case WM_COMMAND:
		switch(LOWORD(wParam))
		{
		case IDM_NEW:		// VK쐬
			DialogBox(g_hInst, MAKEINTRESOURCE(IDD_SIZE), hWnd, ProcDlgNew);
			g_bDisableTools = true;
			if(g_CurToolBtn == 2){
				T_Clear_SelectRect();
			}
			SetRect(&g_rc_select, 0, 0, g_bi1.wdh, g_bi1.hgt);
			return 0;
		case IDM_OPEN:		// J
			Open_FileDlg();
			if(g_CurToolBtn == 2){
				T_Clear_SelectRect();
			}
			SetRect(&g_rc_select, 0, 0, g_bi1.wdh, g_bi1.hgt);
			InvalidateRect(hWnd, NULL, TRUE);
			return 0;
		case IDM_SAVEAS:	// Otĕۑ
			if(g_CurToolBtn == 2){
				T_Clear_SelectRect();
			}
			SetRect(&g_rc_select, 0, 0, g_bi1.wdh, g_bi1.hgt);
			Save_FileDlg();
			return 0;
		case IDM_EXIT:		// I
			SendMessage(hWnd,WM_CLOSE,0,0);
			return 0;
		case IDM_UNDO:		// ɖ߂
			Undo();
			return 0;
		case IDM_COPY:		// Rs[
			if(g_CurToolBtn == 2){
				T_Clear_SelectRect();
			}
			Set_Clipboard_DDB(g_rc_select);
			Set_Clipboard_DIB(g_rc_select);
			SetRect(&g_rc_select, 0, 0, g_bi1.wdh, g_bi1.hgt);
			return 0;
		case IDM_PASTE:		// \t
			M_Paste();
			return 0;
		case IDM_TOOLBOX:	// c[{bNX̕\
			Toggle_ShowWindow(g_hToolbox);
			return 0;
		case IDM_COLORBOX:	// J[{bNX̕\
			Toggle_ShowWindow(g_hColorbox);
			return 0;
		case IDM_ALPHABOX:	// x{bNX̕\
			Toggle_ShowWindow(g_hAlphabox);
			return 0;
		case IDM_INITPOS:	// 
			{
				Init_Positions();
				ShowWindow(g_hToolbox, SW_SHOW);
				ShowWindow(g_hColorbox, SW_SHOW);
				int nCmdShow = SW_SHOW;
				if(!g_bEnableMove){
					nCmdShow = SW_HIDE;
				}
				ShowWindow(g_hAlphabox, nCmdShow);
			}
			return 0;
		}
		break;
	case WM_MENUSELECT:
		UINT index;
		index = (UINT) LOWORD(wParam);
		if(index >= 0){
			HMENU hMenuSub = GetSubMenu(GetMenu(hWnd), index);
			Set_SubMenuState(hMenuSub, index);
			Set_MoveFlag(false);
		}
		return 0;
	case PWM_CHANGEBUTTON:	// c[ύXꂽƂ
		if(wParam == 2){	// ύXÕc[Ic[Ƃ
			T_Clear_SelectRect();
			SetRect(&g_rc_select, 0, 0, g_bi1.wdh, g_bi1.hgt);
		}
		Set_MoveFlag(false);
		return 0;
	case WM_LBUTTONDOWN:
		g_color = g_colorL;
		M_ButtonDown(lParam);
		return 0;
	case WM_RBUTTONDOWN:
		g_color = g_colorR;
		M_ButtonDown(lParam);
		return 0;
	case WM_NCLBUTTONUP:
	case WM_NCRBUTTONUP:
		if(g_bMouseButtonDown){
			g_bMouseButtonDown = false;
			POINTS pts = MAKEPOINTS(lParam);
			POINT pt;
			pt.x = pts.x;
			pt.y = pts.y;
			ScreenToClient(hWnd, &pt);
			M_ButtonUp(pt);
		}
		return 0;
	case WM_LBUTTONUP:
	case WM_RBUTTONUP:
		if(g_bMouseButtonDown){
			g_bMouseButtonDown = false;
			POINT pt;
			pt.x = LOWORD(lParam);
			pt.y = HIWORD(lParam);
			M_ButtonUp(pt);
		}
		return 0;
	case WM_NCMOUSEMOVE:
		if(g_bi1.pBmi){
			POINTS pts = MAKEPOINTS(lParam);
			POINT pt;
			pt.x = pts.x;
			pt.y = pts.y;
			ScreenToClient(hWnd, &pt);
			M_MouseMove(g_bMouseButtonDown, pt);
		}
		return 0;
	case WM_MOUSEMOVE:
		if(g_bi1.pBmi){
			POINT pt;
			pt.x = LOWORD(lParam);
			pt.y = HIWORD(lParam);
			M_MouseMove(g_bMouseButtonDown, pt);
		}
		return 0;
	case WM_PAINT:
		{
			HDC 		hDC;
			PAINTSTRUCT ps;
			hDC = BeginPaint(hWnd,&ps);
			M_Paint(hDC);
			EndPaint(hWnd,&ps);
		}
		return 0;
	case WM_CLOSE:
		Clean_Up();
		DestroyWindow(hWnd);
		PostQuitMessage(0);
		return 0;
	default:
		break;
	}
	return DefWindowProc(hWnd, uMsg, wParam, lParam);
}// ProcWnd

// c[{bNX̃vV[W
LRESULT CALLBACK ProcWndToolbox(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch(uMsg)
	{
	case WM_CREATE:
		return 0;
	case WM_ACTIVATE:
		if(wParam)	g_hDlg = hWnd;
		else		g_hDlg = NULL;
		return 0;
	case WM_PAINT:
		{
			HDC hDC;
			PAINTSTRUCT ps;
			hDC = BeginPaint(hWnd, &ps);
			DrawMarginBorder(hWnd, hDC);
			EndPaint(hWnd, &ps);
		}
		return 0;
	case WM_CLOSE:
		/*
		 * The user closed the toolbox from the system menu.
		 * Hide the toolbox (we don't actually destroy it so
		 * that it will appear in the same spot when they show
		 * it again).
		 */
		ShowWindow(g_hToolbox, SW_HIDE);
		return 0;
	case WM_DESTROY:
		{
			int i;
			for (i = 0; i < CTOOLS; i++) {
				DeleteObject(g_Tools[i].hbmToolBtnUp);
				g_Tools[i].hbmToolBtnUp = NULL;
				DeleteObject(g_Tools[i].hbmToolBtnDown);
				g_Tools[i].hbmToolBtnDown = NULL;
			}
			/*
			 * Null out the global window handle for the toolbox
			 * for safety's sake.
			 */
			g_hToolbox = NULL;
		}
		return 0;
	default:
		break;
	}
	return DefWindowProc(hWnd, uMsg, wParam, lParam);
}// ProcWndToolbox

// c[{^̃vV[W
LRESULT CALLBACK ProcWndToolBtn(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch(uMsg)
	{
	case WM_LBUTTONDOWN:
		// CEBhEɒʒm
		SendMessage(g_hWnd, PWM_CHANGEBUTTON, g_CurToolBtn, 0);
		/*
		 * Select the tool that was clicked on.
		 */
		ToolboxSelectTool((UINT)GetWindowLong((hWnd), GWL_ID));
		return 0;
	case WM_PAINT:
		{
			HDC hDC;
			PAINTSTRUCT ps;
			hDC = BeginPaint(hWnd, &ps);
			ToolboxDrawBitmap(hDC, (UINT)GetWindowLong((hWnd), GWL_ID));
			EndPaint(hWnd, &ps);
		}
		return 0;
	default:
		break;
	}
	return DefWindowProc(hWnd, uMsg, wParam, lParam);
}// ProcWndToolBtn

// J[{bNX̃vV[W
BOOL CALLBACK ProcDlgColor(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	static HWND hPic[18];
	static COLORREF colorS[16] =	{RGB(0,0,0),RGB(255,255,255),RGB(127,127,127),RGB(191,191,191),
									 RGB(0,0,127),RGB(0,0,255),RGB(0,127,127),RGB(0,255,255),
									 RGB(0,127,0),RGB(0,255,0),RGB(127,127,0),RGB(255,255,0),
									 RGB(127,0,0),RGB(255,0,0),RGB(127,0,127),RGB(255,0,255)
									};
	
	switch(uMsg)
	{
	case WM_INITDIALOG:
		hPic[0] = GetDlgItem(hDlg, IDC_STATIC01);
		hPic[1] = GetDlgItem(hDlg, IDC_STATIC02);
		hPic[2] = GetDlgItem(hDlg, IDC_STATIC03);
		hPic[3] = GetDlgItem(hDlg, IDC_STATIC04);
		hPic[4] = GetDlgItem(hDlg, IDC_STATIC05);
		hPic[5] = GetDlgItem(hDlg, IDC_STATIC06);
		hPic[6] = GetDlgItem(hDlg, IDC_STATIC07);
		hPic[7] = GetDlgItem(hDlg, IDC_STATIC08);
		hPic[8] = GetDlgItem(hDlg, IDC_STATIC09);
		hPic[9] = GetDlgItem(hDlg, IDC_STATIC10);
		hPic[10] = GetDlgItem(hDlg, IDC_STATIC11);
		hPic[11] = GetDlgItem(hDlg, IDC_STATIC12);
		hPic[12] = GetDlgItem(hDlg, IDC_STATIC13);
		hPic[13] = GetDlgItem(hDlg, IDC_STATIC14);
		hPic[14] = GetDlgItem(hDlg, IDC_STATIC15);
		hPic[15] = GetDlgItem(hDlg, IDC_STATIC16);
		hPic[16] = GetDlgItem(hDlg, IDC_STATIC17);
		hPic[17] = GetDlgItem(hDlg, IDC_STATIC18);
		break;
	case WM_ACTIVATE:
		if(wParam)	g_hDlg = hDlg;
		else		g_hDlg = NULL;
		break;
	case WM_LBUTTONUP:
		M_ButtonUpColorbox(hDlg, hPic, colorS, lParam, true);
		break;
	case WM_RBUTTONUP:
		M_ButtonUpColorbox(hDlg, hPic, colorS, lParam, false);
		break;
	case WM_PAINT:
		{
			HDC hDC;
			PAINTSTRUCT ps;
			hDC = BeginPaint(hDlg, &ps);
			RECT rc[18];
			int i;
			for(i=0;i<18;i++){
				rc[i] = Get_ControlRect(hDlg, hPic[i]);
				rc[i].right -= rc[i].left;
				rc[i].bottom -= rc[i].top;
			}
			Fill_Rect(hDC, rc[0].left, rc[0].top, rc[0].right, rc[0].bottom, g_colorL, false);
			Fill_Rect(hDC, rc[1].left, rc[1].top, rc[1].right, rc[1].bottom, g_colorR, false);
			for(i=0;i<16;i++){
				Fill_Rect(hDC, rc[i+2].left, rc[i+2].top, rc[i+2].right, rc[i+2].bottom, colorS[i], false);
			}
			EndPaint(hDlg, &ps);
		}
		break;
	case WM_CLOSE:
		ShowWindow(g_hColorbox, SW_HIDE);
		break;
	case WM_DESTROY:
		g_hColorbox = NULL;
		break;
	default:
		return false;
	}
	return true;
}// ProcDlgColor

// x{bNX̃vV[W
BOOL CALLBACK ProcDlgAlpha(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	static HICON hIconADTP,hIconAUTP;
	
	switch(uMsg)
	{
	case WM_INITDIALOG:
		{
			SendDlgItemMessage(hDlg,IDC_SLIDER1,TBM_SETTICFREQ,127,0);
			SendDlgItemMessage(hDlg,IDC_SLIDER1,TBM_SETRANGE,TRUE,MAKELONG(0,255));
			SendDlgItemMessage(hDlg,IDC_SLIDER1,TBM_SETPOS,TRUE,0);
			hIconADTP = LoadIcon(g_hInst, MAKEINTRESOURCE(IDI_ADTP));
			hIconAUTP = LoadIcon(g_hInst, MAKEINTRESOURCE(IDI_AUTP));
			SendDlgItemMessage(hDlg,IDC_CHECK1,BM_SETIMAGE,IMAGE_ICON,(LPARAM)hIconAUTP);
		}
		break;
	case WM_ACTIVATE:
		if(wParam)	g_hDlg = hDlg;
		else		g_hDlg = NULL;
		break;
	case WM_VSCROLL:	// XC_[Ƃ
		{
			HWND	hSldr = (HWND) lParam;
			ULONG	dl = SendMessage(hSldr,TBM_GETPOS,0,0);
			char str[4];
			itoa(dl, str, 10);
			SendDlgItemMessage(hDlg,IDC_STATIC1,WM_SETTEXT,0,(LPARAM)str);
			g_nAlpha = 255 - dl;
			if(BST_CHECKED == IsDlgButtonChecked(hDlg, IDC_CHECK1)){
				CheckDlgButton(hDlg, IDC_CHECK1, BST_UNCHECKED);
				SendDlgItemMessage(hDlg,IDC_CHECK1,BM_SETIMAGE,IMAGE_ICON,(LPARAM)hIconAUTP);
				g_bTransparent = false;
			}
			Init_Plg();
			InvalidateRect(g_hWnd, &g_bi1.rc, FALSE);
		}
		break;
	case WM_COMMAND:
		switch(LOWORD(wParam))
		{
		case IDC_CHECK1:
			if(HIWORD(wParam) == BN_CLICKED){
				UINT st = SendDlgItemMessage(hDlg,IDC_CHECK1,BM_GETCHECK,0,0);
				if(st == BST_CHECKED){
					g_bTransparent = true;
					SendDlgItemMessage(hDlg,IDC_CHECK1,BM_SETIMAGE,IMAGE_ICON,(LPARAM)hIconADTP);
				}
				else{
					g_bTransparent = false;
					SendDlgItemMessage(hDlg,IDC_CHECK1,BM_SETIMAGE,IMAGE_ICON,(LPARAM)hIconAUTP);
				}
				Init_Plg();
				InvalidateRect(g_hWnd, &g_bi1.rc, FALSE);
				
			}
			break;
		default:
			return false;
		}
		break;
	case WM_CLOSE:
		ShowWindow(g_hAlphabox, SW_HIDE);
		break;
	case WM_DESTROY:
		g_hAlphabox = NULL;
		break;
	default:
		return false;
	}
	return true;
}// ProcDlgAlpha

// VK쐬_CAÕvV[W
BOOL CALLBACK ProcDlgNew(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch(uMsg)
	{
	case WM_INITDIALOG:
		SendDlgItemMessage(hDlg,IDC_EDIT1,EM_SETLIMITTEXT,4,0);
		SendDlgItemMessage(hDlg,IDC_EDIT2,EM_SETLIMITTEXT,4,0);
		SendDlgItemMessage(hDlg,IDC_SPIN1,UDM_SETRANGE,0,MAKELONG(4096,0));
		SendDlgItemMessage(hDlg,IDC_SPIN2,UDM_SETRANGE,0,MAKELONG(4096,0));
		SendDlgItemMessage(hDlg,IDC_SPIN1,UDM_SETPOS,0,MAKELONG(256,0));
		SendDlgItemMessage(hDlg,IDC_SPIN2,UDM_SETPOS,0,MAKELONG(256,0));
		break;
	case WM_ACTIVATE:
		if(wParam)	g_hDlg = hDlg;
		else		g_hDlg = NULL;
		break;
	case WM_COMMAND:
		switch(LOWORD(wParam))
		{
		case IDOK:
			{
				Release_Memory();
				BITMAPINFOHEADER	bmih;
				ZeroMemory(&bmih, sizeof(bmih));
				bmih.biSize = sizeof(BITMAPINFOHEADER);
				bmih.biBitCount = 24;
				bmih.biPlanes = 1;
				bmih.biCompression = BI_RGB;
				char str[256] = "";
				GetDlgItemText(hDlg, IDC_EDIT1, str, sizeof(str));
				bmih.biWidth = atoi(str);
				GetDlgItemText(hDlg, IDC_EDIT2, str, sizeof(str));
				bmih.biHeight = atoi(str);
				g_bi1.size_pBmi = BmiSize(&bmih);
				g_bi1.pBmi = (BITMAPINFO*) new BYTE [g_bi1.size_pBmi];
				ZeroMemory(g_bi1.pBmi, g_bi1.size_pBmi);
				g_bi1.pBmi->bmiHeader = bmih;
				g_bi1.widthbytes = BytesPerLine(&g_bi1.pBmi->bmiHeader);
				g_bi1.wdh = g_bi1.pBmi->bmiHeader.biWidth;
				g_bi1.hgt = g_bi1.pBmi->bmiHeader.biHeight;
				g_bi1.pBmi->bmiHeader.biSizeImage = g_bi1.widthbytes * g_bi1.hgt;
				g_bi1.hBmp = CreateDIBSection(NULL, g_bi1.pBmi, DIB_RGB_COLORS, (void**)&g_bi1.pBits, NULL, 0);
				int x,y,pos;
				for(y=0;y<g_bi1.hgt;y++){
					for(x=0;x<g_bi1.wdh;x++){
						pos = y * g_bi1.widthbytes + x * (g_bi1.pBmi->bmiHeader.biBitCount / 8);
						g_bi1.pBits[pos+0] = 0xff;
						g_bi1.pBits[pos+1] = 0xff;
						g_bi1.pBits[pos+2] = 0xff;
					}
				}
				g_bi1.size_pBits = g_bi1.pBmi->bmiHeader.biSizeImage;
				SetRect(&g_bi1.rc, 0, 0, g_bi1.wdh, g_bi1.hgt);
				strcpy(g_filename, "new.bmp");
				InvalidateRect(g_hWnd, NULL, FALSE);
			}
			EndDialog (hDlg,true);
			return true;
		case IDCANCEL:
			EndDialog (hDlg,false);
			return true;
		}
		return false;
	default:
		return false;
	}
	return true;
}// ProcDlgNew

// y[Xg摜̈ړ\tO̐ݒ
void Set_MoveFlag(bool bEnable)
{
	int nCmdShow = SW_SHOW;
	if(!bEnable){
		nCmdShow = SW_HIDE;
		InvalidateRect(g_hWnd, &g_bi1.rc, FALSE);
	}
	g_bEnableMove = bEnable;
	ShowWindow(g_hAlphabox, nCmdShow);
}// Set_MoveFlag

// Rg[̃NCAgWԂ
RECT Get_ControlRect(HWND hDlg, HWND hCtrl)
{
	RECT rcSrc,rcDst;
	POINT pt;
	GetWindowRect(hCtrl, &rcSrc);
	rcDst.right  = rcSrc.right - rcSrc.left;
	rcDst.bottom = rcSrc.bottom - rcSrc.top;
	pt.x = rcSrc.left;
	pt.y = rcSrc.top;
	ScreenToClient(hDlg, &pt);
	rcDst.left = pt.x;
	rcDst.top  = pt.y;
	rcDst.right  += rcDst.left;
	rcDst.bottom += rcDst.top;
	return rcDst;
}// Get_ControlRect

// Bresenham ̐ASY
// x1,y1Fn_̍WAx2,y2FI_̍WAclrFF
void Bre_Line(HDC hDC, int x1, int y1, int x2, int y2, COLORREF clr, UINT thick)
{
	int dx,dy;
	
	dx = abs(x2 - x1);
	dy = abs(y2 - y1);
	
	if(dx <= dy){
		Bre_Line_Sub(hDC, dx, dy, x1, y1, x2, y2, clr, thick, true);
	}
	else{
		Bre_Line_Sub(hDC, dy, dx, y1, x1, y2, x2, clr, thick, false);
	}
}// Bre_Line

void Bre_Line_Sub(HDC hDC, int dx, int dy, int x1, int y1, int x2, int y2, COLORREF clr, UINT thick, bool bSlantGently)
{
	int d,x,y,yend,i1,i2,ix;
	
	d = 2 * dx - dy;
	i1 = 2 * dx;
	i2 = 2 * (dx - dy);
	if((x1 <= x2 && y1 <= y2) || (x1 >= x2 && y1 >= y2)){
		ix = 1;
	}
	else{
		ix = -1;
	}
	if(y1 > y2){
		x = x2;
		y = y2;
		yend = y1;
	}
	else{
		x = x1;
		y = y1;
		yend = y2;
	}
	Bre_Write_Pixel(hDC, x, y, clr, thick, bSlantGently);
	while(y < yend){
		y ++;
		if(d < 0){
			d += i1;
		}
		else{
			x += ix;
			d += i2;
		}
		Bre_Write_Pixel(hDC, x, y, clr, thick, bSlantGently);
	}
}// Bre_Line_Sub

void Bre_Write_Pixel(HDC hDC, int x, int y, COLORREF clr, UINT thick, bool bSlantGently)
{
	int x2,y2;
	
	if(bSlantGently){
		x2 = x;
		y2 = y;
	}
	else{
		x2 = y;
		y2 = x;
	}
	if(thick == 1){
		SetPixelV(hDC, x2, y2, clr);
	}
	else{
		Fill_Rect(hDC, x2-thick/2+2, y2-thick/2, thick, thick, clr, false);
	}
}// Bre_Write_Pixel

// `̓hׂ
void Fill_Rect(HDC hDC, UINT x, UINT y, UINT width, UINT height, COLORREF clr, bool flag_RopInvert)
{
	DWORD dwRop = PATCOPY;
	if(flag_RopInvert){
		dwRop = DSTINVERT;
	}
	HBRUSH hbr, hbrOld;
	hbr = CreateSolidBrush(clr);
	hbrOld = (HBRUSH) SelectObject(hDC, hbr);
	PatBlt(hDC, x, y, width, height, dwRop);
	SelectObject(hDC, hbrOld);
	DeleteObject(hbr);
}// Fill_Rect

// hׂc[
void T_Flood_Fill(HWND hWnd, UINT x, UINT y, COLORREF clr)
{
	if(g_bi1.pBmi && g_bi1.pBits){
		HDC hDC = GetDC(hWnd);
		HDC hDCcp = CreateCompatibleDC(hDC);
		HBITMAP hBmpPre = (HBITMAP) SelectObject(hDCcp, g_bi1.hBmp);
		COLORREF clr_pos = GetPixel(hDCcp, x, y);
		HBRUSH hbr, hbrOld;
		hbr = CreateSolidBrush(clr);
		hbrOld = (HBRUSH) SelectObject(hDCcp, hbr);
		ExtFloodFill(hDCcp, x, y, clr_pos, FLOODFILLSURFACE);
		SelectObject(hDCcp, hbrOld);
		DeleteObject(hbr);
		BitBlt(hDC, 0, 0, g_bi1.wdh, g_bi1.hgt, hDCcp, 0, 0, SRCCOPY);
		SelectObject(hDCcp, hBmpPre);
		DeleteDC(hDCcp);
		ReleaseDC(hWnd, hDC);
	}
}// T_Flood_Fill

// X|Cgc[
void T_Spuit(HWND hWnd, UINT x, UINT y)
{
	if(g_bi1.pBmi && g_bi1.pBits){
		HDC hDC = GetDC(hWnd);
		HDC hDCcp = CreateCompatibleDC(hDC);
		HBITMAP hBmpPre = (HBITMAP) SelectObject(hDCcp, g_bi1.hBmp);
		COLORREF clr_pos = GetPixel(hDCcp, x, y);
		if(g_color == g_colorL){
			g_colorL = clr_pos;
		}
		else{
			g_colorR = clr_pos;
		}
		SelectObject(hDCcp, hBmpPre);
		DeleteDC(hDCcp);
		ReleaseDC(hWnd, hDC);
	}
}// T_Spuit

// c[̈ē̕`
void T_Draw_Line_Pre(HDC hDC, POINT pt_pre, POINT pt_now, POINT pt_now_pre)
{
	SetROP2(hDC, R2_NOT);	// XN[̐F𔽓]
	if(pt_now_pre.x != -1){	// ȑO̐
		MoveToEx(hDC, pt_pre.x, pt_pre.y, NULL);
		LineTo(hDC, pt_now_pre.x, pt_now_pre.y);
	}
	MoveToEx(hDC, pt_pre.x, pt_pre.y, NULL);
	LineTo(hDC, pt_now.x, pt_now.y);
}// T_Draw_Line_Pre

// c[
void T_Draw_Line(HDC hDC, POINT pt_pre, POINT pt_now_pre)
{
	// ē
	SetROP2(hDC, R2_NOT);
	MoveToEx(hDC, pt_pre.x, pt_pre.y, NULL);
	LineTo(hDC, pt_now_pre.x, pt_now_pre.y);
	SetROP2(hDC, R2_COPYPEN);
	// ̕`
	HPEN hPen, hPenOld;
	hPen = CreatePen(PS_SOLID, 1, g_color);
	hPenOld = (HPEN) SelectObject(hDC, hPen);
	MoveToEx(hDC, pt_pre.x, pt_pre.y, NULL);
	LineTo(hDC, pt_now_pre.x, pt_now_pre.y);
	SelectObject(hDC, hPenOld);
	DeleteObject(hPen);
}// T_Draw_Line

// `c[̈ē̕`
// flag_ellipse F ȉ~tOifalse`, trueȉ~j
void T_Draw_Rect_Pre(HDC hDC, RECT rc1, RECT rc2, bool flag_ellipse)
{
	SetROP2(hDC, R2_NOT);	// XN[̐F𔽓]
	HBRUSH hbr, hbrOld;
	hbr = (HBRUSH) GetStockObject(NULL_BRUSH);
	hbrOld = (HBRUSH) SelectObject(hDC, hbr);
	if(rc1.right != -1){	// ȑO̐
		if(!flag_ellipse)
			Rectangle(hDC, rc1.left, rc1.top, rc1.right, rc1.bottom);
		else
			Ellipse(hDC, rc1.left, rc1.top, rc1.right, rc1.bottom);
	}
	if(!flag_ellipse)
		Rectangle(hDC, rc2.left, rc2.top, rc2.right, rc2.bottom);
	else
		Ellipse(hDC, rc2.left, rc2.top, rc2.right, rc2.bottom);
	SelectObject(hDC, hbrOld);
	SetROP2(hDC, R2_COPYPEN);
}// T_Draw_Rect_Pre

// `c[̈ē̏
void T_Clear_Rect_Pre(HDC hDC, RECT rc1, bool flag_ellipse)
{
	SetROP2(hDC, R2_NOT);
	HBRUSH hbr, hbrOld;
	hbr = (HBRUSH) GetStockObject(NULL_BRUSH);
	hbrOld = (HBRUSH) SelectObject(hDC, hbr);
	if(!flag_ellipse)
		Rectangle(hDC, rc1.left, rc1.top, rc1.right, rc1.bottom);
	else
		Ellipse(hDC, rc1.left, rc1.top, rc1.right, rc1.bottom);
	SelectObject(hDC, hbrOld);
	SetROP2(hDC, R2_COPYPEN);
}// T_Clear_Rect_Pre

// `c[
// flag_ellipse F ȉ~tOifalse`, trueȉ~j
// flag_fill    F hׂtOifalse, truehׂj
void T_Draw_Rect(HDC hDC, RECT rc1, RECT rc2, bool flag_ellipse, bool flag_fill)
{
	// ē
	T_Clear_Rect_Pre(hDC, rc1, flag_ellipse);
	// `̕`
	HBRUSH hbr, hbrOld;
	HPEN hPen, hPenOld;
	hPen = CreatePen(PS_SOLID, 1, g_color);
	hPenOld = (HPEN) SelectObject(hDC, hPen);
	if(!flag_fill){
		hbr = (HBRUSH) GetStockObject(NULL_BRUSH);
		hbrOld = (HBRUSH) SelectObject(hDC, hbr);
		if(!flag_ellipse)
			Rectangle(hDC, rc2.left, rc2.top, rc2.right, rc2.bottom);
		else
			Ellipse(hDC, rc2.left, rc2.top, rc2.right, rc2.bottom);
		SelectObject(hDC, hbrOld);
	}
	else{
		hbr = CreateSolidBrush(g_color);
		hbrOld = (HBRUSH) SelectObject(hDC, hbr);
		if(!flag_ellipse)
			Rectangle(hDC, rc2.left, rc2.top, rc2.right, rc2.bottom);
		else
			Ellipse(hDC, rc2.left, rc2.top, rc2.right, rc2.bottom);
		SelectObject(hDC, hbrOld);
	}
	SelectObject(hDC, hPenOld);
	DeleteObject(hPen);
}// T_Draw_Rect

// Of[Vc[
void T_Draw_RectGrad(HDC hDC, RECT rc1, RECT rc2)
{
	// ē
	T_Clear_Rect_Pre(hDC, rc1, false);
	// `̕`
	TRIVERTEX        vert[2] ;
	GRADIENT_RECT    gRect;
	vert [0] .x      = rc1.left;
	vert [0] .y      = rc1.top;
	vert [0] .Red    = GetRValue(g_colorL) << 8;
	vert [0] .Green  = GetGValue(g_colorL) << 8;
	vert [0] .Blue   = GetBValue(g_colorL) << 8;
	vert [0] .Alpha  = 0x0000;
	vert [1] .x      = rc1.right;
	vert [1] .y      = rc1.bottom; 
	vert [1] .Red    = GetRValue(g_colorR) << 8;
	vert [1] .Green  = GetGValue(g_colorR) << 8;
	vert [1] .Blue   = GetBValue(g_colorR) << 8;
	vert [1] .Alpha  = 0x0000;
	gRect.UpperLeft  = 0;
	gRect.LowerRight = 1;
	GradientFill(hDC, vert, 2, &gRect, 1, GRADIENT_FILL_RECT_V);
}// T_Draw_RectGrad

// Ig̕`
RECT T_Draw_SelectRect(HDC hDC, POINT pt_pre, POINT pt_now, POINT pt_now_pre)
{
	RECT rc1,rc2;
	if(pt_pre.x < pt_now.x){
		rc1.left = pt_pre.x;
		rc1.right = pt_now.x;
	}
	else{
		rc1.left = pt_now.x;
		rc1.right = pt_pre.x;
	}
	if(pt_pre.y < pt_now.y){
		rc1.top = pt_pre.y;
		rc1.bottom = pt_now.y;
	}
	else{
		rc1.top = pt_now.y;
		rc1.bottom = pt_pre.y;
	}
	if(pt_pre.x < pt_now_pre.x){
		rc2.left = pt_pre.x;
		rc2.right = pt_now_pre.x;
	}
	else{
		rc2.left = pt_now_pre.x;
		rc2.right = pt_pre.x;
	}
	if(pt_pre.y < pt_now_pre.y){
		rc2.top = pt_pre.y;
		rc2.bottom = pt_now_pre.y;
	}
	else{
		rc2.top = pt_now_pre.y;
		rc2.bottom = pt_pre.y;
	}
	if(pt_now_pre.x != -1){	// ȑO̐
		DrawFocusRect(hDC, &rc2);
	}
	DrawFocusRect(hDC, &rc1);
	return rc1;
}// T_Draw_SelectRect

void T_Clear_SelectRect()
{
	if(g_bi1.pBmi && g_bi1.pBits && g_pBitsCp){
		memcpy(g_bi1.pBits, g_pBitsCp, g_bi1.size_pBits);
		InvalidateRect(g_hWnd, &g_bi1.rc, FALSE);
		Release_MemoryCopy();
	}
}// T_Clear_SelectRect

void M_Paste()
{
	int		fmt;
	UINT	fmt_list[] = {CF_DIB,CF_BITMAP};
	fmt = GetPriorityClipboardFormat(fmt_list,sizeof(fmt_list)/sizeof(UINT));
	BMPINF *bi = NULL;
	if(g_bi1.pBmi && g_bi1.pBits){
		bi = &g_bi2;
	}
	else{
		bi = &g_bi1;
	}
	if(fmt == CF_DIB){
		if(!Get_Clipboard_DIB(bi)){
			if(!Get_Clipboard_DDB(bi)){
				return;
			}
		}
	}
	else if(fmt == CF_BITMAP){
		if(!Get_Clipboard_DDB(bi)){
			return;
		}
	}
	if(bi == &g_bi2){
		Set_MoveFlag(true);
		ToolboxSelectTool(2);
		Set_Undo();
	}
}// M_Paste

void M_Paint(HDC hDC)
{
	HDC 	hDCcp1,hDCcp2;
	HBITMAP	hBmpPre1,hBmpPre2;
	if(g_bi1.pBmi && g_bi1.pBits){
		hDCcp1 = CreateCompatibleDC(hDC);
		if(g_pBitsCp && g_bi2.pBmi && g_bi2.pBits){
			memcpy(g_bi1.pBits, g_pBitsCp, g_bi1.size_pBits);
		}
		hBmpPre1 = (HBITMAP) SelectObject(hDCcp1, g_bi1.hBmp);
		if(g_bi2.pBmi && g_bi2.pBits){
			hDCcp2 = CreateCompatibleDC(hDCcp1);
			hBmpPre2 = (HBITMAP) SelectObject(hDCcp2, g_bi2.hBmp);
		}
		if(!g_bDisableTools && !g_bEnableMove){
			RECT rc1 = {g_pt_pre.x, g_pt_pre.y, g_pt_now_pre.x, g_pt_now_pre.y};
			RECT rc2 = {g_pt_pre.x, g_pt_pre.y, g_pt_now.x, g_pt_now.y};
			switch(g_CurToolBtn)
			{
			case 0:	// yc[
				if(g_bMouseButtonDown){
					Bre_Line(hDCcp1, g_pt_pre.x, g_pt_pre.y, g_pt_now.x, g_pt_now.y, g_color, 1);
					g_pt_pre = g_pt_now;
				}
				break;
			case 1:	// yCgc[
				if(g_bMouseButtonDown){
					Bre_Line(hDCcp1, g_pt_pre.x, g_pt_pre.y, g_pt_now.x, g_pt_now.y, g_color, 12);
					g_pt_pre = g_pt_now;
				}
				break;
			case 2:	// Ic[
				if(g_bMouseButtonDown){
					g_rc_select = T_Draw_SelectRect(hDCcp1, g_pt_pre, g_pt_now, g_pt_now_pre);
					g_pt_now_pre = g_pt_now;
				}
				break;
			case 3:	// c[
				if(g_bMouseButtonDown){
					T_Draw_Line_Pre(hDCcp1, g_pt_pre, g_pt_now, g_pt_now_pre);
					g_pt_now_pre = g_pt_now;
				}
				else{
					if(g_pt_now_pre.x != -1){
						T_Draw_Line(hDCcp1, g_pt_pre, g_pt_now_pre);
						g_pt_now_pre.x = -1;
						g_pt_now_pre.y = -1;
					}
				}
				break;
			case 4:	// `c[
			case 5:	// `hׂc[
			case 6:	// ȉ~c[
			case 7:	// ȉ~hׂc[
			case 10:// Of[Vc[
				bool flag_ellipse = false;
				if(g_CurToolBtn == 6 || g_CurToolBtn == 7){
					flag_ellipse = true;
				}
				if(g_bMouseButtonDown){
					T_Draw_Rect_Pre(hDCcp1, rc1, rc2, flag_ellipse);
					g_pt_now_pre = g_pt_now;
				}
				else{
					if(g_pt_now_pre.x != -1){
						bool flag_fill = false;
						if(g_CurToolBtn == 5 || g_CurToolBtn == 7){
							flag_fill = true;
						}
						if(g_CurToolBtn == 10){
							T_Draw_RectGrad(hDCcp1, rc1, rc2);
						}
						else{
							T_Draw_Rect(hDCcp1, rc1, rc2, flag_ellipse, flag_fill);
						}
						g_pt_now_pre.x = -1;
						g_pt_now_pre.y = -1;
					}
				}
				break;
			}
		}
		if(g_bi2.pBmi && g_bi2.pBits){
			RECT rc = {g_bi2.rc.left, g_bi2.rc.top, g_bi2.wdh, g_bi2.hgt};
			if(g_bPlg){
				POINT pt[3] = { {g_bi2.rc.left + g_pt_move.x, g_bi2.rc.top + g_pt_move.y},
								{g_bi2.rc.right + g_pt_move.x, g_bi2.rc.top + g_pt_move.y},
								{g_bi2.rc.left, g_bi2.rc.bottom} };
				PlgBlt(hDCcp1, pt, hDCcp2, 0, 0, g_bi2.wdh, g_bi2.hgt, NULL, 0, 0);
			}
			else if(g_bTransparent){			// F
				TransparentBlt(hDCcp1, g_bi2.rc.left, g_bi2.rc.top, g_bi2.wdh, g_bi2.hgt,
								hDCcp2, 0, 0, g_bi2.wdh, g_bi2.hgt, g_colorR);
			}
			else if(g_nAlpha < 255){	// 
				BLENDFUNCTION bf;
				bf.BlendOp = AC_SRC_OVER;
				bf.AlphaFormat = 0;
				bf.BlendFlags = 0;
				bf.SourceConstantAlpha = g_nAlpha;
				AlphaBlend(hDCcp1, g_bi2.rc.left, g_bi2.rc.top, g_bi2.wdh, g_bi2.hgt,
								hDCcp2, 0, 0, g_bi2.wdh, g_bi2.hgt, bf);
			}
			else{						// x^
				BitBlt(hDCcp1, rc.left, rc.top, rc.right, rc.bottom, hDCcp2, 0, 0, SRCCOPY);
			}
			if(g_bEnableMove){
				// y[Xg摜g
				Draw_EnableMoveRect(hDCcp1, g_bi2.rc, 2, RGB(255,255,255), PS_SOLID);
				Draw_EnableMoveRect(hDCcp1, g_bi2.rc, 2, RGB(0,0,0), PS_DASH);
				// slӌ`nh
				if(g_rc_plg.top > 0){
					Fill_Rect(hDCcp1, g_rc_plg.left, g_rc_plg.top, 10, 10, 0, true);
				}
			}
			else{
				Release_Memory2();
				Release_MemoryCopy();
			}
		}
		BitBlt(hDC, 0, 0, g_bi1.wdh, g_bi1.hgt, hDCcp1, 0, 0, SRCCOPY);
		if(g_bi2.pBmi && g_bi2.pBits){
			SelectObject(hDCcp2, hBmpPre2);
			DeleteDC(hDCcp2);
		}
		SelectObject(hDCcp1, hBmpPre1);
		DeleteDC(hDCcp1);
	}
}// M_Paint

void M_ButtonDown(LPARAM lParam)
{
	if(g_bi1.pBmi){
		g_bPlgMoving = false;
		g_bPasteMoving = false;
		if(g_bEnableMove){
			// slӌ`nhɃ|C^Ă邩
			if(PtInRect(&g_rc_plg, g_pt_now)){
				g_bPlgMoving = true;
				g_bPlg = true;
			}
			// y[Xg摜Ƀ|C^Ă邩
			if(PtInRect(&g_bi2.rc, g_pt_now)){
				g_bPasteMoving = true;
			}
			// y[Xg摜Ȉꍇ
			if(!g_bPasteMoving && !g_bPlgMoving){
				Set_MoveFlag(false);
				return;
			}
		}
		POINT pt;
		pt.x = LOWORD(lParam);
		pt.y = HIWORD(lParam);
		if(PtInRect(&g_bi1.rc, pt)){
			switch(g_CurToolBtn)
			{
			case 0:	// yc[
			case 1:	// yCgc[
			case 3:	// c[
			case 4:	// `c[
			case 5:	// `hׂc[
			case 6:	// ȉ~c[
			case 7:	// ȉ~hׂc[
			case 8:	// hׂc[
			case 10:// Of[Vc[
				Set_Undo();
				break;
			}
			if(!g_bMouseButtonDown){
				g_bMouseButtonDown = true;
				g_pt_pre = pt;
			}
			if(g_bPlgMoving){
				SetCursor(g_hcurPlg);
			}
			else if(g_bPasteMoving){
				SetCursor(g_hcurHand);
			}
			else if(!g_bEnableMove){
				SetCursor(g_Tools[g_CurToolBtn].hcur);
			}
			switch(g_CurToolBtn)
			{
			case 2:	// Ic[
				if(!g_bEnableMove){
					T_Clear_SelectRect();
					SetRect(&g_rc_select, 0, 0, g_bi1.wdh, g_bi1.hgt);
					Allocate_MemoryCopy();
				}
//				g_pt_now.x = g_pt_pre.x + 1;
//				g_pt_now.y = g_pt_pre.y + 1;
			case 0:	// yc[
			case 1:	// yCgc[
				InvalidateRect(g_hWnd, &g_bi1.rc, FALSE);
				break;
			}
		}
		if(g_bDisableTools){
			g_bDisableTools = false;
		}
	}
}// M_ButtonDown

void M_ButtonUp(POINT pt)
{
	if(g_bi1.pBmi){
		if( pt.x >= 0 && pt.x < g_bi1.wdh && pt.y >= 0 && pt.y < g_bi1.hgt)
		{
			if(g_bPlgMoving){
				SetCursor(g_hcurPlg);
			}
			else if(g_bPasteMoving){
				SetCursor(g_hcurHand);
			}
			else if(!g_bEnableMove){
				SetCursor(g_Tools[g_CurToolBtn].hcur);
			}
			switch(g_CurToolBtn)
			{
			case 8:	// hׂc[
				{
					HCURSOR hCurOld = SetCursor(g_hcurWait);
					T_Flood_Fill(g_hWnd, g_pt_now.x, g_pt_now.y, g_color);
					SetCursor(hCurOld);
				}
				break;
			case 9:	// X|Cgc[
				T_Spuit(g_hWnd, g_pt_now.x, g_pt_now.y);
				InvalidateRect(g_hColorbox, &g_bi1.rc, TRUE);
				break;
			}
		}
		switch(g_CurToolBtn)
		{
		case 2:
			g_pt_now_pre.x = -1;
			g_pt_now_pre.y = -1;
			break;
		case 3:	// c[
		case 4:	// `c[
		case 5:	// `hׂc[
		case 6:	// ȉ~c[
		case 7:	// ȉ~hׂc[
		case 10:// Of[Vc[
			InvalidateRect(g_hWnd, &g_bi1.rc, FALSE);
			break;
		}
	}
}// M_ButtonUp

void M_MouseMove(bool bMouseButtonDown, POINT pt)
{
	if(g_bi2.pBmi && g_bi2.pBits){
		g_pt_now = pt;
		if(g_pt_now.x < 0)
			g_pt_now.x = 0;
		if(g_pt_now.x > g_bi1.wdh)
			g_pt_now.x = g_bi1.wdh;
		if(g_pt_now.y < 0)
			g_pt_now.y = 0;
		if(g_pt_now.y > g_bi1.hgt)
			g_pt_now.y = g_bi1.hgt;
		// y[Xg摜hbÕJ[\ݒ
		if(PtInRect(&g_rc_plg, g_pt_now) || (g_bEnableMove && bMouseButtonDown && g_bPlgMoving)){
			SetCursor(g_hcurPlg);
		}
		if(PtInRect(&g_bi2.rc, g_pt_now) || (g_bEnableMove && bMouseButtonDown && g_bPasteMoving)){
			SetCursor(g_hcurHand);
		}
		// nh摜Ƀ|C^Ăă{^ĂꍇAy[Xg摜ό`A܂͈ړ
		if(g_bEnableMove && bMouseButtonDown){
			if(g_pt_pre.x != g_pt_now.x || g_pt_pre.y != g_pt_now.y){
				if(g_bPlgMoving){
					g_pt_move.x += g_pt_now.x - g_pt_pre.x;
					g_pt_move.y += g_pt_now.y - g_pt_pre.y;
					Set_PlgRect();
				}
				else if(g_bPasteMoving){
					g_bi2.rc.left += (g_pt_now.x - g_pt_pre.x);
					g_bi2.rc.top += (g_pt_now.y - g_pt_pre.y);
					SetRect(&g_bi2.rc, g_bi2.rc.left, g_bi2.rc.top, g_bi2.rc.left+g_bi2.wdh, g_bi2.rc.top+g_bi2.hgt);
					Set_PlgRect();
				}
			}
			g_pt_pre = g_pt_now;
		}
		InvalidateRect(g_hWnd, &g_bi1.rc, FALSE);
	}
	else{
		if( pt.x >= 0 && pt.x < g_bi1.wdh && 
			pt.y >= 0 && pt.y < g_bi1.hgt)
		{
			SetCursor(g_Tools[g_CurToolBtn].hcur);
		}
		g_pt_now = pt;
		switch(g_CurToolBtn)
		{
		case 0:	// yc[
		case 1:	// yCgc[
		case 2:	// Ic[
		case 3:	// c[
		case 4:	// `c[
		case 5:	// `hׂc[
		case 6:	// ȉ~c[
		case 7:	// ȉ~hׂc[
		case 10:// Of[Vc[
			if(g_pt_now.x < 0)
				g_pt_now.x = 0;
			if(g_pt_now.x > g_bi1.wdh)
				g_pt_now.x = g_bi1.wdh;
			if(g_pt_now.y < 0)
				g_pt_now.y = 0;
			if(g_pt_now.y > g_bi1.hgt)
				g_pt_now.y = g_bi1.hgt;
			InvalidateRect(g_hWnd, &g_bi1.rc, FALSE);
			break;
		}
	}
}// M_MouseMove

void M_ButtonUpColorbox(HWND hDlg, HWND *hPic, COLORREF *colorS, LPARAM lParam, bool bLeft)
{
	POINT	pt;
	int		i;
	pt.x = LOWORD(lParam);
	pt.y = HIWORD(lParam);
	RECT rc[18];
	for(i=0;i<18;i++){
		rc[i] = Get_ControlRect(hDlg, hPic[i]);
		if(PtInRect(&rc[i], pt)){
			if(i < 2){
				if(i == 0){
					Open_ColorDlg(hDlg, true);
				}
				else{
					Open_ColorDlg(hDlg, false);
				}
				InvalidateRect(hDlg, &rc[i], TRUE);
			}
			else{
				if(bLeft){
					g_colorL = colorS[i-2];
					InvalidateRect(hDlg, &rc[0], TRUE);
				}
				else{
					g_colorR = colorS[i-2];
					InvalidateRect(hDlg, &rc[1], TRUE);
				}
			}
		}
	}
}// M_ButtonUpColorbox

// slӌ`ւ̕ό`Zbg
void Init_Plg()
{
	if(g_bPlg){
		ZeroMemory(&g_pt_move, sizeof(g_pt_move));
		Set_PlgRect();
		g_bPlg = false;
	}
}// Init_Plg

// slӌ`nh̋`ݒ
void Set_PlgRect()
{
	if(g_bi2.pBmi){
		int x,y;
		x = g_bi2.rc.right + g_pt_move.x;
		y = g_bi2.rc.top + g_pt_move.y;
		SetRect(&g_rc_plg,  x, y - 10, x + 10, y);
	}
}// Set_PlgRect

// \t摜̈ړ\ł邱Ƃg̕\
void Draw_EnableMoveRect(HDC hDC, RECT rc, UINT thick, COLORREF clr, UINT style)
{
	LOGBRUSH lbr;
	HPEN hPen, hPenOld;
	HBRUSH hbr, hbrOld;
	lbr.lbStyle = BS_SOLID;
	lbr.lbColor = clr;
	lbr.lbHatch = 0;
	hPen = ExtCreatePen(PS_GEOMETRIC | style, thick, &lbr, 0, NULL);
	hPenOld = (HPEN) SelectObject(hDC, hPen);
	hbr = (HBRUSH) GetStockObject(NULL_BRUSH);
	hbrOld = (HBRUSH) SelectObject(hDC, hbr);
	Rectangle(hDC, rc.left, rc.top, rc.right, rc.bottom);
	SelectObject(hDC, hbrOld);
	SelectObject(hDC, hPenOld);
	DeleteObject(hPen);
}// Draw_EnableMoveRect

// c[{bNX̓gŕ`
void DrawMarginBorder(HWND hWnd, HDC hDC)
{
	HBRUSH hbrOld;
	HPEN hpenOld;
	RECT rc;
	GetClientRect(hWnd, &rc);
	hpenOld = (HPEN)SelectObject(hDC, GetStockObject(BLACK_PEN));
	hbrOld = (HBRUSH)SelectObject(hDC, GetStockObject(NULL_BRUSH));
	Rectangle(hDC, g_xMargin, g_yMargin,
			rc.right - g_xMargin, rc.bottom - g_yMargin);
	SelectObject(hDC, hpenOld);
	SelectObject(hDC, hbrOld);
}// DrawMarginBorder

// c[{^IꂽƂ
void ToolboxSelectTool(int tool)
{
	if(g_CurToolBtn != tool){
		if(g_hToolbox){
			InvalidateRect(GetDlgItem(g_hToolbox, g_CurToolBtn), NULL, FALSE);
			InvalidateRect(GetDlgItem(g_hToolbox, tool), NULL, FALSE);
		}
		g_CurToolBtn = tool;
	}
}// ToolboxSelectTool

// c[{^̃rbg}bvύX
void ToolboxDrawBitmap(HDC hDC, int tool)
{
	HDC hMemDC;
	HBITMAP hbmOld;
	/*
	 * Draw the image.
	 */
	hMemDC = CreateCompatibleDC(hDC);
	hbmOld = (HBITMAP)SelectObject(hMemDC, (tool == g_CurToolBtn) ?
			g_Tools[tool].hbmToolBtnDown : g_Tools[tool].hbmToolBtnUp);
	BitBlt(hDC, 0, 0, g_cxToolBtn, g_cyToolBtn, hMemDC, 0, 0, SRCCOPY);
	SelectObject(hMemDC, hbmOld);
	DeleteDC(hMemDC);
}// ToolboxDrawBitmap

// c[{bNX̍쐬
bool Create_ToolBox()
{
	// Load the bitmaps.
	int i;
	for (i = 0; i < CTOOLS; i++) {
		if (!(g_Tools[i].hbmToolBtnUp = LoadBitmap(g_hInst,
					MAKEINTRESOURCE(g_Tools[i].idbmToolBtnUp))))
			return false;
    
		if (!(g_Tools[i].hbmToolBtnDown = LoadBitmap(g_hInst,
					MAKEINTRESOURCE(g_Tools[i].idbmToolBtnDown))))
			return false;
	}
	// Get the dimensions of the tool button bitmaps.
	BITMAP bmp;
	GetObject(g_Tools[0].hbmToolBtnUp, sizeof(BITMAP), (PSTR)&bmp);
	g_cxToolBtn = bmp.bmWidth;
	g_cyToolBtn = bmp.bmHeight;
	// Calculate the required window size for the client area size we want.
	UINT style = WS_POPUP | WS_CLIPSIBLINGS | WS_CAPTION | WS_SYSMENU;
	UINT styleEx = WS_EX_TOOLWINDOW;
	RECT rc;
	rc.left = 0;
	rc.top  = 0;
	rc.right  = g_xMargin + ((g_cxToolBtn - 1) * 2) + 1 + g_xMargin;
	rc.bottom = g_yMargin + ((g_cyToolBtn - 1) * (CTOOLS / 2 + CTOOLS % 2)) + 1 + g_yMargin;
	AdjustWindowRectEx(&rc, style, FALSE, styleEx);
	int cx = rc.right - rc.left;
	int cy = rc.bottom - rc.top;
	// Calculate the required window position we want.
	RECT rcClient;
	POINT pt;
	GetClientRect(g_hWnd, &rcClient);
	pt.x = rcClient.right - cx;
	pt.y = rcClient.top;
	ClientToScreen(g_hWnd, &pt);
	// Create the toolbox.
	g_hToolbox = CreateWindowEx(styleEx, szToolboxClass, "°", style, pt.x, pt.y, cx, cy, g_hWnd,
								NULL, g_hInst, NULL);
	if(!g_hToolbox){
		return false;
	}
	// Create the buttons.
	int x = g_xMargin;
	int y = g_yMargin;
	for(i = 0; i < CTOOLS; i++) {
		CreateWindowEx(0, szToolBtnClass, NULL, WS_CHILD | WS_VISIBLE, x, y, g_cxToolBtn,
						g_cyToolBtn, g_hToolbox, (HMENU)i, g_hInst, NULL);
		if(x == g_xMargin) {
			x += g_cxToolBtn - 1;
		}
		else{
			x = g_xMargin;
			y += g_cyToolBtn - 1;
		}
	}
	// ŏ̃c[{^I
	ToolboxSelectTool(0);
	// c[{bNX̕\
	ShowWindow(g_hToolbox, SW_SHOW);
	return true;
}// Create_ToolBox

// J[_CAO
// bLeft	F {^true, E{^false
void Open_ColorDlg(HWND hWnd, bool bLeft)
{
	static COLORREF CustColors[16] = {
						RGB(255, 255, 255), RGB(255, 255, 255),
						RGB(255, 255, 255), RGB(255, 255, 255),
						RGB(255, 255, 255), RGB(255, 255, 255),
						RGB(255, 255, 255), RGB(255, 255, 255),
						RGB(255, 255, 255), RGB(255, 255, 255),
						RGB(255, 255, 255), RGB(255, 255, 255),
						RGB(255, 255, 255), RGB(255, 255, 255),
						RGB(255, 255, 255), RGB(255, 255, 255)
					};
	CHOOSECOLOR	cc;
	ZeroMemory(&cc, sizeof(cc));
	cc.lStructSize = sizeof(CHOOSECOLOR);
	cc.hwndOwner = hWnd;
	if(bLeft)
		cc.rgbResult = g_colorL;
	else
		cc.rgbResult = g_colorR;
	cc.lpCustColors = CustColors;
	cc.Flags = CC_RGBINIT;
	if(ChooseColor(&cc)){
		if(bLeft)
			g_colorL = cc.rgbResult;
		else
			g_colorR = cc.rgbResult;
	}
}// Open_ColorDlg

// qEBhE̕\E\ύX
void Toggle_ShowWindow(HWND hWnd)
{
	if(IsWindowVisible(hWnd)){
		ShowWindow(hWnd, SW_HIDE);
	}
	else{
		ShowWindow(hWnd, SW_SHOW);
	}
}// Toggle_ShowWindow

// qEBhE̕\E\̃j[ACẽ`FbNύX
void Toggle_CheckShowWindow(HWND hWnd, HMENU hMenu, UINT menuID)
{
	if(IsWindowVisible(hWnd)){
		Menu_Check(hMenu, menuID, true);
	}
	else{
		Menu_Check(hMenu, menuID, false);
	}
}// Toggle_CheckShowWindow

// qEBhEʒuɈړ
void Init_Positions()
{
	RECT	rcClient,rcTB,rcCB,rcAB;
	POINT	pt;
	UINT	wdhTB,hgtTB,wdhCB,hgtCB,wdhAB,hgtAB;
	GetWindowRect(g_hToolbox, &rcTB);
	GetClientRect(g_hWnd, &rcClient);
	wdhTB = rcTB.right - rcTB.left;
	hgtTB = rcTB.bottom - rcTB.top;
	pt.x = rcClient.right - wdhTB;
	pt.y = rcClient.top;
	ClientToScreen(g_hWnd, &pt);
	MoveWindow(g_hToolbox, pt.x, pt.y, wdhTB, hgtTB, TRUE);
	GetWindowRect(g_hColorbox, &rcCB);
	wdhCB = rcCB.right - rcCB.left;
	hgtCB = rcCB.bottom - rcCB.top;
	pt.x = rcClient.right - wdhCB;
	pt.y = rcClient.top + hgtTB;
	ClientToScreen(g_hWnd, &pt);
	MoveWindow(g_hColorbox, pt.x, pt.y, wdhCB, hgtCB, TRUE);
	GetWindowRect(g_hAlphabox, &rcAB);
	wdhAB = rcAB.right - rcAB.left;
	hgtAB = rcAB.bottom - rcAB.top;
	pt.x = rcClient.right - wdhCB - wdhCB;
	pt.y = rcClient.top + hgtTB;
	ClientToScreen(g_hWnd, &pt);
	MoveWindow(g_hAlphabox, pt.x, pt.y, wdhAB, hgtAB, TRUE);
}// Init_Positions

// }EXJ[\t@C̓ǂݍ
void Set_Hcursor()
{
	g_hcurWait = LoadCursor(NULL, IDC_WAIT);
	g_hcurHand = LoadCursor(g_hInst, MAKEINTRESOURCE(IDC_HAND_L));
	g_hcurPlg = LoadCursor(g_hInst, MAKEINTRESOURCE(IDC_PLG));
	g_Tools[0].hcur =
			LoadCursor(g_hInst, MAKEINTRESOURCE(IDC_PENCIL));
	g_Tools[1].hcur =
			LoadCursor(g_hInst, MAKEINTRESOURCE(IDC_BRUSH));
	g_Tools[2].hcur =
	g_Tools[3].hcur =
	g_Tools[4].hcur =
	g_Tools[5].hcur =
	g_Tools[6].hcur =
	g_Tools[7].hcur =
	g_Tools[10].hcur =
			LoadCursor(g_hInst, MAKEINTRESOURCE(IDC_CROSS2));
	g_Tools[8].hcur =
			LoadCursor(g_hInst, MAKEINTRESOURCE(IDC_FLOOD));
	g_Tools[9].hcur =
			LoadCursor(g_hInst, MAKEINTRESOURCE(IDC_SPUIT));
}// Set_Hcursor

// Tuj[ACȅԐݒ
void Set_SubMenuState(HMENU hMenuSub, int index)
{
	switch(index)
	{
	case 0:	// t@C
		if(!g_bi1.pBmi || !g_bi1.pBits){
			EnableMenuItem(hMenuSub, 3, MF_GRAYED | MF_BYPOSITION);
		}
		else{
			EnableMenuItem(hMenuSub, 3, MF_ENABLED | MF_BYPOSITION);
		}
		break;
	case 1:
		{
			if(!g_biUndo.pBmi || !g_biUndo.pBits){
				EnableMenuItem(hMenuSub, 0, MF_GRAYED | MF_BYPOSITION);
			}
			else{
				EnableMenuItem(hMenuSub, 0, MF_ENABLED | MF_BYPOSITION);
			}
			if((!g_bi1.pBmi || !g_bi1.pBits) || (g_rc_select.left == g_rc_select.right
						|| g_rc_select.top == g_rc_select.bottom)){
				EnableMenuItem(hMenuSub, 2, MF_GRAYED | MF_BYPOSITION);
			}
			else{
				EnableMenuItem(hMenuSub, 2, MF_ENABLED | MF_BYPOSITION);
			}
			int		fmt;
			UINT	fmt_list[] = {CF_DIB};
			fmt = GetPriorityClipboardFormat(fmt_list,sizeof(fmt_list)/sizeof(UINT));
			if(fmt <= 0){
				EnableMenuItem(hMenuSub, 3, MF_GRAYED | MF_BYPOSITION);
			}
			else{
				EnableMenuItem(hMenuSub, 3, MF_ENABLED | MF_BYPOSITION);
			}
		}
		break;
	case 2:	// \
		Toggle_CheckShowWindow(g_hToolbox, hMenuSub, IDM_TOOLBOX);
		Toggle_CheckShowWindow(g_hColorbox, hMenuSub, IDM_COLORBOX);
		Toggle_CheckShowWindow(g_hAlphabox, hMenuSub, IDM_ALPHABOX);
		break;
	}
}// Set_SubMenuState

// j[ACe`FbNi^Oj
void Menu_Check(HMENU hMenu, UINT ID, bool bCheck)
{
	MENUITEMINFO    mi;
	ZeroMemory (&mi, sizeof(mi));
	mi.cbSize = sizeof(mi);
	mi.fMask = MIIM_STATE;
	if(bCheck)
		mi.fState = MFS_CHECKED;
	else
		mi.fState = MFS_UNCHECKED;
	
	SetMenuItemInfo(hMenu,ID,0,&mi);
}// Menu_Check

// DIB  BITMAPINFO \̃TCYԂ
WORD BmiSize(LPBITMAPINFOHEADER lpbih)
{
	return (sizeof(BITMAPINFOHEADER) + BitMaskSize(lpbih) + PaletteSize(lpbih));
}// BmiMaskSize

// DIB ̃sNZtH[}bg TCYԂ
WORD BitMaskSize(LPBITMAPINFOHEADER lpbih)
{
	WORD mask_size = 0;
	if(lpbih->biCompression == BI_BITFIELDS)
		mask_size = sizeof(DWORD) * 3;
	return mask_size;
}// BitMaskSize

// DIB ̃pbg TCYԂ
WORD PaletteSize( LPBITMAPINFOHEADER lpbih )
{
	return ( DIBNumColors( lpbih ) * sizeof( RGBQUAD ) );
}// PaletteSize

// DIB ̐FԂ
WORD DIBNumColors( LPBITMAPINFOHEADER lpbih )
{
	int num;
	if(lpbih->biBitCount > 8)
		num = 0;
	else if(lpbih->biClrUsed == 0)
		num = 1 << lpbih->biBitCount;
	else
		num = lpbih->biClrUsed;
	return num;
}// DIBNumColors

// DIB  4byte EԂ
DWORD BytesPerLine( LPBITMAPINFOHEADER lpbih )
{
	return WIDTHBYTES(lpbih->biWidth * lpbih->biPlanes * lpbih->biBitCount);
}// BytesPerLine

// Nbv{[hDIBǂݍ
bool Get_Clipboard_DIB(BMPINF *bi)
{
	HANDLE		hMem;
	BITMAPINFO	*pbmi = NULL;
	BYTE		*pbits = NULL;
	
	if(bi == &g_bi1){
		Release_Memory1();
	}
	else{
		Release_Memory2();
	}
	OpenClipboard(NULL);
	hMem = GetClipboardData(CF_DIB);
	if(!hMem){
		CloseClipboard();
		return 0;
	}
	pbmi = (LPBITMAPINFO) GlobalLock (hMem);
	if(!pbmi){
		GlobalUnlock(hMem);
		CloseClipboard();
		return 0;
	}
	bi->size_pBmi = BmiSize(&pbmi->bmiHeader);
	bi->widthbytes = BytesPerLine(&pbmi->bmiHeader);
	bi->size_pBits = bi->widthbytes * pbmi->bmiHeader.biHeight;
	pbits = (LPBYTE)pbmi + bi->size_pBmi;
	if(!pbmi || !pbits){
		GlobalUnlock(hMem);
		CloseClipboard();
		return 0;
	}
	bi->pBmi = (BITMAPINFO*) new BYTE [bi->size_pBmi];
	memcpy(bi->pBmi, pbmi, bi->size_pBmi);
	bi->hBmp = CreateDIBSection(NULL, bi->pBmi, DIB_RGB_COLORS, (void**)&bi->pBits, NULL, 0);
	memcpy(bi->pBits, pbits, bi->size_pBits);
	GlobalUnlock(hMem);
	CloseClipboard();
	bi->wdh = bi->pBmi->bmiHeader.biWidth;
	bi->hgt = bi->pBmi->bmiHeader.biHeight;
	SetRect(&bi->rc, 0, 0, bi->wdh, bi->hgt);
	if(bi == &g_bi2){
		if(g_CurToolBtn == 2){
			T_Clear_SelectRect();
		}
		Allocate_MemoryCopy();
	}
	return 1;
}// Get_Clipboard_DIB

// Nbv{[hDDBǂݍ
bool Get_Clipboard_DDB(BMPINF *bi)
{
	HBITMAP				hBmp = NULL;
	BYTE				*pbits = NULL;
	BITMAPINFOHEADER	bmih;
	BITMAP				bm;
	
	if(bi == &g_bi1){
		Release_Memory1();
	}
	else{
		Release_Memory2();
	}
	OpenClipboard(NULL);
	hBmp = (HBITMAP) GetClipboardData(CF_BITMAP);
	if(!hBmp){
		CloseClipboard();
		return 0;
	}
	if(!GetObject(hBmp, sizeof(bm), &bm)){
		CloseClipboard();
		return 0;
	}
	// DDB24bitFDIBɕϊ
	ZeroMemory(&bmih, sizeof(bmih));
	bmih.biSize			= sizeof(bmih);
	bmih.biWidth		= bm.bmWidth;
	bmih.biHeight		= bm.bmHeight;
	bmih.biPlanes		= 1;
	bmih.biBitCount		= 24;
	bmih.biCompression	= BI_RGB;
	bi->widthbytes = BytesPerLine(&bmih);
	bi->size_pBits = bi->widthbytes * bmih.biHeight;
	bmih.biSizeImage = bi->size_pBits;
	bi->size_pBmi = BmiSize(&bmih);
	bi->pBmi = (BITMAPINFO*) new BYTE [bi->size_pBmi];
	bi->pBmi->bmiHeader = bmih;
	bi->hBmp = CreateDIBSection(NULL, bi->pBmi, DIB_RGB_COLORS, (void**)&bi->pBits, NULL, 0);
	pbits = new BYTE [bi->size_pBits];
	if(!pbits){
		CloseClipboard();
		return 0;
	}
	HDC hDC = GetDC(g_hWnd);
	GetDIBits(hDC, hBmp, 0, bm.bmHeight, pbits, bi->pBmi, NULL);
	ReleaseDC(g_hWnd, hDC);
	memcpy(bi->pBits, pbits, bi->size_pBits);
	delete[] pbits;
	pbits = NULL;
	CloseClipboard();
	bi->wdh = bi->pBmi->bmiHeader.biWidth;
	bi->hgt = bi->pBmi->bmiHeader.biHeight;
	SetRect(&bi->rc, 0, 0, bi->wdh, bi->hgt);
	if(bi == &g_bi2){
		if(g_CurToolBtn == 2){
			T_Clear_SelectRect();
		}
		Allocate_MemoryCopy();
	}
	return 1;
}// Get_Clipboard_DDB

// Nbv{[hDIBu
void Set_Clipboard_DIB(RECT rc)
{
	HANDLE	hMem = NULL;
	BYTE	*buf = NULL;
	
	Set_Clipboard_Sub(rc);
	OpenClipboard(NULL);
	EmptyClipboard();
	hMem = GlobalAlloc(GMEM_MOVEABLE, g_cb.size_pBmi + g_cb.size_pBits);
	buf = (LPBYTE) GlobalLock(hMem);
	memcpy(buf, g_cb.pBmi, g_bi1.size_pBmi);
	memcpy(buf + g_cb.size_pBmi, g_cb.pBits, g_cb.size_pBits);
	Release_MemoryClpbrd();
	SetClipboardData(CF_DIB, hMem);
	GlobalUnlock(hMem);
	CloseClipboard();
}// Set_Clipboard_DIB

// Nbv{[hDDBu
void Set_Clipboard_DDB(RECT rc)
{
	Set_Clipboard_Sub(rc);
	HDC hDC = GetDC(g_hWnd);
	HBITMAP hBmp = CreateDIBitmap(hDC, &(g_cb.pBmi->bmiHeader), CBM_INIT,
									g_cb.pBits, g_cb.pBmi, DIB_RGB_COLORS);
	ReleaseDC(g_hWnd, hDC);
	Release_MemoryClpbrd();
	if(hBmp){
		OpenClipboard(NULL);
		EmptyClipboard();
		SetClipboardData(CF_BITMAP, hBmp);
		CloseClipboard();
	}
}// Set_Clipboard_DDB

// ÏDIBݒ
void Set_Clipboard_Sub(RECT rc)
{
	BITMAPINFOHEADER	bmih;
	int					x,y,y2,bpp,stride;
	
	Release_MemoryClpbrd();
	bmih = g_bi1.pBmi->bmiHeader;
	bmih.biWidth = rc.right - rc.left;
	bmih.biHeight = rc.bottom - rc.top;
	bmih.biSizeImage = BytesPerLine(&bmih) * bmih.biHeight;
	g_cb.pBmi = (BITMAPINFO*) new BYTE [g_bi1.size_pBmi];
	memcpy(g_cb.pBmi, g_bi1.pBmi, g_bi1.size_pBmi);
	g_cb.pBmi->bmiHeader = bmih;
	g_cb.pBits = new BYTE [bmih.biSizeImage];
	bpp = bmih.biBitCount;
	stride = BytesPerLine(&bmih);
	for(y=0;y<bmih.biHeight;y++){
		y2 = bmih.biHeight - y - 1;
		if(bpp >= 8){
			for(x=0;x<bmih.biWidth*(bpp/8);x++){
				g_cb.pBits[y2*stride+x] = g_bi1.pBits[(y2+(g_bi1.hgt-rc.bottom))
												*g_bi1.widthbytes+x+rc.left*(bpp/8)];
			}
		}
		else{
			for(x=0;x<bmih.biWidth;x++){
				g_cb.pBits[y2*stride+x/(8/bpp)] = g_bi1.pBits[(y2+(g_bi1.hgt-rc.bottom))
												*g_bi1.widthbytes+x/(8/bpp)+rc.left/(8/bpp)];
			}
		}
	}
	g_cb.size_pBmi = g_bi1.size_pBmi;
	g_cb.size_pBits = bmih.biSizeImage;
}// Set_Clipboard_Sub

// mɖ߂nobt@Ƀf[^i[
void Set_Undo()
{
	if(g_bi1.pBmi && g_bi1.pBits){
		Release_MemoryUndo();
		g_biUndo.size_pBmi = g_bi1.size_pBmi;
		g_biUndo.size_pBits = g_bi1.size_pBits;
		g_biUndo.widthbytes = g_bi1.widthbytes;
		g_biUndo.wdh = g_bi1.wdh;
		g_biUndo.hgt = g_bi1.hgt;
		g_biUndo.rc = g_bi1.rc;
		g_biUndo.pBmi = (BITMAPINFO*) new BYTE [g_biUndo.size_pBmi];
		memcpy(g_biUndo.pBmi, g_bi1.pBmi, g_biUndo.size_pBmi);
		g_biUndo.hBmp = CreateDIBSection(NULL, g_biUndo.pBmi, DIB_RGB_COLORS,
										(void**)&g_biUndo.pBits, NULL, 0);
		memcpy(g_biUndo.pBits, g_bi1.pBits, g_biUndo.size_pBits);
	}
}// Set_Undo

// mɖ߂n̎s
void Undo()
{
	if(g_biUndo.pBmi && g_biUndo.pBits){
		Release_Memory1();
		g_bi1.size_pBmi		= g_biUndo.size_pBmi;
		g_bi1.size_pBits	= g_biUndo.size_pBits;
		g_bi1.widthbytes	= g_biUndo.widthbytes;
		g_bi1.wdh			= g_biUndo.wdh;
		g_bi1.hgt			= g_biUndo.hgt;
		g_bi1.rc			= g_biUndo.rc;
		g_bi1.pBmi = (BITMAPINFO*) new BYTE [g_bi1.size_pBmi];
		memcpy(g_bi1.pBmi, g_biUndo.pBmi, g_bi1.size_pBmi);
		g_bi1.hBmp = CreateDIBSection(NULL, g_bi1.pBmi, DIB_RGB_COLORS, (void**)&g_bi1.pBits, NULL, 0);
		memcpy(g_bi1.pBits, g_biUndo.pBits, g_bi1.size_pBits);
		if(g_pBitsCp){
			Release_MemoryCopy();
			g_pBitsCp = new BYTE [g_biUndo.size_pBits];
			memcpy(g_pBitsCp, g_biUndo.pBits, g_biUndo.size_pBits);
		}
		SetRect(&g_rc_select, 0, 0, g_bi1.wdh, g_bi1.hgt);
		Release_MemoryUndo();
	}
}// Undo

// I[vt@C_CAO
void Open_FileDlg()
{
	OPENFILENAME	ofn;
	char			fn[MAX_PATH] = "";
	
	ZeroMemory(&ofn, sizeof(OPENFILENAME));
	ofn.lStructSize = sizeof(OPENFILENAME);
	ofn.hwndOwner = g_hWnd;
	ofn.Flags = OFN_HIDEREADONLY | OFN_EXTENSIONDIFFERENT;
	ofn.lpstrFile = fn;
	ofn.nMaxFile = sizeof(fn);
	ofn.lpstrDefExt = "bmp";
	ofn.lpstrFilter =	"rbg}bv (*.bmp)\0" "*.bmp\0" 
						"ׂẴt@C (*.*)\0" "*.*\0";
	ofn.nFilterIndex = 1;
	if(GetOpenFileName(&ofn)){
		Load_Bmp(fn);
	}
}// Open_FileDlg

// ۑt@C_CAO
void Save_FileDlg()
{
	OPENFILENAME	ofn;
	char			fn[MAX_PATH];
	
	strcpy(fn, g_filename);
	
	ZeroMemory(&ofn, sizeof(OPENFILENAME));
	ofn.lStructSize  = sizeof(OPENFILENAME);
	ofn.hwndOwner    = g_hWnd;
	ofn.Flags        = OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT | OFN_EXTENSIONDIFFERENT;
	ofn.lpstrFile    = fn;
	ofn.lpstrDefExt  = "bmp";
	ofn.nMaxFile     = sizeof(fn);
	ofn.lpstrFilter =	"rbg}bv (*.bmp)\0" "*.bmp\0" 
						"ׂẴt@C (*.*)\0" "*.*\0";
	ofn.nFilterIndex = 1;
	if(GetSaveFileName(&ofn)){
		Save_Bmp(fn);
	}
}// Save_FileDlg

// rbg}bv t@C̓ǂݍ
void Load_Bmp(char *filename)
{
	HANDLE				hfile;
	DWORD				tmp;
	BITMAPFILEHEADER	bmfh;
	BITMAPINFOHEADER	bmih;
	
	Release_Memory();
	hfile = CreateFile(filename, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, 0, NULL);
	ReadFile(hfile, &bmfh, sizeof(bmfh), &tmp, NULL);
	ReadFile(hfile, &bmih, sizeof(bmih), &tmp, NULL);
	g_bi1.size_pBmi = BmiSize(&bmih);
	// BITMAPINFO \̂̃m
	g_bi1.pBmi = (BITMAPINFO*) new BYTE [g_bi1.size_pBmi];
	ZeroMemory(g_bi1.pBmi, g_bi1.size_pBmi);
	// BITMAPINFOHEADER Rs[
	g_bi1.pBmi->bmiHeader = bmih;
	// pbg}XN̓ǂݍ
	if(g_bi1.pBmi->bmiHeader.biBitCount <= 8){
		ReadFile(hfile, &g_bi1.pBmi->bmiColors, PaletteSize(&bmih), &tmp, NULL);
	}
	else if(bmih.biCompression == BI_BITFIELDS){
		ReadFile(hfile, &g_bi1.pBmi->bmiColors, BitMaskSize(&bmih), &tmp, NULL);
	}
	// DIBHBITMAP쐬
	g_bi1.hBmp = CreateDIBSection(NULL, g_bi1.pBmi, DIB_RGB_COLORS, (void**)&g_bi1.pBits, NULL, 0);
	// sNZf[^̓ǂݍ
	SetFilePointer(hfile, bmfh.bfOffBits, NULL, FILE_BEGIN);
	g_bi1.widthbytes = BytesPerLine(&g_bi1.pBmi->bmiHeader);
	g_bi1.pBmi->bmiHeader.biSizeImage = g_bi1.widthbytes * g_bi1.pBmi->bmiHeader.biHeight;
	ReadFile(hfile, g_bi1.pBits, g_bi1.pBmi->bmiHeader.biSizeImage, &tmp, NULL);
	// t@C
	CloseHandle(hfile);
	g_bi1.wdh = g_bi1.pBmi->bmiHeader.biWidth;
	g_bi1.hgt = g_bi1.pBmi->bmiHeader.biHeight;
	g_bi1.size_pBits = g_bi1.pBmi->bmiHeader.biSizeImage;
	SetRect(&g_bi1.rc, 0, 0, g_bi1.wdh, g_bi1.hgt);
	strcpy(g_filename, filename);
}// Load_Bmp

// rbg}bv̕ۑ
void Save_Bmp(char *filename)
{
	HANDLE				hfile;
	DWORD				tmp;
	BITMAPFILEHEADER	bmfh;
	
	ZeroMemory(&bmfh, sizeof(bmfh));
	bmfh.bfType = 0x4d42;
	bmfh.bfOffBits = sizeof(bmfh) + g_bi1.size_pBmi;
	bmfh.bfSize = bmfh.bfOffBits + g_bi1.size_pBits;
	hfile = CreateFile(filename, GENERIC_WRITE, FILE_SHARE_WRITE, NULL, CREATE_ALWAYS, 0, NULL);
	WriteFile(hfile, &bmfh, sizeof(bmfh), &tmp, NULL);
	WriteFile(hfile, g_bi1.pBmi, g_bi1.size_pBmi, &tmp, NULL);
	WriteFile(hfile, g_bi1.pBits, g_bi1.size_pBits, &tmp, NULL);
	CloseHandle(hfile);
}// Save_Bmp

// C摜NApobt@̊m
void Allocate_MemoryCopy()
{
	if(g_bi1.pBmi && g_bi1.pBits){
		Release_MemoryCopy();
		g_pBitsCp = new BYTE [g_bi1.size_pBits];
		memcpy(g_pBitsCp, g_bi1.pBits, g_bi1.size_pBits);
	}
}// Allocate_MemoryCopy

// C摜NApobt@̉
void Release_MemoryCopy()
{
	if(g_pBitsCp){
		delete[] g_pBitsCp;
		g_pBitsCp = NULL;
	}
}// Release_MemoryCopy

// C摜̃obt@̉
void Release_Memory1()
{
	if(g_bi1.pBmi){
		delete[] (BYTE*) g_bi1.pBmi;
		g_bi1.pBmi = NULL;
	}
	DeleteObject(g_bi1.hBmp);
	g_bi1.hBmp = NULL;
	ZeroMemory(&g_bi1, sizeof(g_bi1));
}// Release_Memory1

// y[Xg摜̃obt@̉
void Release_Memory2()
{
	if(g_bi2.pBmi){
		delete[] (BYTE*) g_bi2.pBmi;
		g_bi2.pBmi = NULL;
	}
	DeleteObject(g_bi2.hBmp);
	g_bi2.hBmp = NULL;
	ZeroMemory(&g_bi2, sizeof(g_bi2));
	SetRect(&g_rc_plg, 0, 0, 0, 0);
	ZeroMemory(&g_pt_move, sizeof(g_pt_move));
	g_bPlg = false;
}// Release_Memory2

// mɖ߂ñobt@̉
void Release_MemoryUndo()
{
	if(g_biUndo.pBmi){
		delete[] (BYTE*) g_biUndo.pBmi;
		g_biUndo.pBmi = NULL;
	}
	DeleteObject(g_biUndo.hBmp);
	g_biUndo.hBmp = NULL;
	ZeroMemory(&g_biUndo, sizeof(g_biUndo));
}// Release_MemoryUndo

// Nbv{[hBitmapu߂̃obt@̉
void Release_MemoryClpbrd()
{
	if(g_cb.pBmi){
		delete[] (BYTE*) g_cb.pBmi;
		g_cb.pBmi = NULL;
	}
	if(g_cb.pBits){
		delete[] g_cb.pBits;
		g_cb.pBits = NULL;
	}
	ZeroMemory(&g_cb, sizeof(g_cb));
}// Release_MemoryClpbrd

void Release_Memory()
{
	Release_MemoryCopy();
	Release_Memory1();
	Release_Memory2();
	Release_MemoryUndo();
	Release_MemoryClpbrd();
}// Release_Memory

void Clean_Up()
{
	Release_Memory();
}// Clean_Up
